#include "view/sink_wgt.h"
#include "$(appName).h"

#define USR_TEXT_LENGTH_MAX 64
#define DEFAULT_FONT_SIZE 30
#define SMALL_FONT_SIZE DEFAULT_FONT_SIZE * 0.8

#define FONT_TAG "font_size="

Evas_Object *
_create_sink_wgt(Evas_Object *parent)
{
	Evas_Object *wgt = NULL;
	char user_text_style[USR_TEXT_LENGTH_MAX] = {0,};

	if (!parent) {
		dlog_print(DLOG_ERROR, LOG_TAG, "sink_wgt_create: parent is NULL");
		return NULL;
	}

	wgt = elm_entry_add(parent);

	if (!wgt) {
		dlog_print(DLOG_ERROR, LOG_TAG, "sink_wgt_create: failure to allocate resource");
		return NULL;
	}

	elm_entry_input_panel_enabled_set(wgt, EINA_FALSE);
	elm_entry_scrollable_set(wgt, EINA_TRUE);

	/* red color text: */
	snprintf(user_text_style, USR_TEXT_LENGTH_MAX, "DEFAULT='font_size=%d color=#ff0000'", (int)(SMALL_FONT_SIZE));
	elm_entry_text_style_user_push(wgt, user_text_style);

	return wgt;
}

void
_paste_sink_wgt_text(Evas_Object *wgt)
{
	/* use paste mechanism: */
	/* sink widget is of 'Entry' type so callback can be NULL: */
	elm_cnp_selection_get(wgt, ELM_SEL_TYPE_PRIMARY, ELM_SEL_FORMAT_TEXT, NULL, NULL);
}
